<template>
  <a :href="linkTo" class="text-white">
    <b-card no-body style="">
      <div
        style="position: absolute;width:100%;height: 100%;top:0; left:0; z-index: 0;background-color: #000000;"
      >
        <b-img-lazy
          :src="imgUrl"
          :alt="title"
          style="object-fit: cover;object-position: 50% 50%;width: 100%; height: 100%;"
        ></b-img-lazy>
      </div>
      <b-card-body
        style="z-index: 1;background: linear-gradient(to right, rgba(0, 0, 0, 0.80), rgba(0, 0, 0, 0.1));"
      >
        <b-card-title title-tag="h2" class="text-decoration-underline"
          >{{ title }}
        </b-card-title>

        <b-card-sub-title
          v-html="date"
          sub-title-tag="h4"
          sub-title-text-variant="white"
        ></b-card-sub-title>

        <b-card-text :class="widthClass">{{ text }} </b-card-text>
      </b-card-body>
    </b-card>
  </a>
</template>

<script>
export default {
  props: {
    eventEntry: {
      type: Object,
      default: () => {
        return {};
      },
    },
    widthClass: {
      type: String,
      default: '',
    },
    boxMaxCol: {
      type: Number,
      default: 1,
    },
  },
  computed: {
    imagMaxWidth() {
      return Math.ceil(1920 / this.boxMaxCol);
    },
    title() {
      if (!this.eventEntry || !this.eventEntry.title) {
        return '';
      }

      if (
        this.eventEntry.title[this.$i18n.locale] &&
        this.eventEntry.title[this.$i18n.locale] !== ''
      ) {
        return this.eventEntry.title[this.$i18n.locale];
      }

      return this.eventEntry.title.en;
    },
    text() {
      if (!this.eventEntry || !this.eventEntry.description) {
        return '';
      }

      if (
        this.eventEntry.description[this.$i18n.locale] &&
        this.eventEntry.description[this.$i18n.locale] !== ''
      ) {
        return this.eventEntry.description[this.$i18n.locale];
      }

      return this.eventEntry.description.en;
    },
    date() {
      if (
        !this.eventEntry ||
        !this.eventEntry.dateStart ||
        !this.eventEntry.dateEnd
      ) {
        return '';
      }

      const start = new Date(this.eventEntry.dateStart.replace('+0000', 'Z'));
      const end = new Date(this.eventEntry.dateEnd.replace('+0000', 'Z'));

      const loc = this.$i18n.locale + '-' + this.$i18n.locale.toUpperCase();

      if (start.getUTCDay() === end.getUTCDay()) {
        return this._oneDay(start, end, loc, this.eventEntry.showTime);
      }

      return this._moreDay(start, end, loc, this.eventEntry.showTime);
    },
    imgUrl() {
      return (
        process.env.baseURL +
        '/media/image/' +
        this.eventEntry.imageId +
        '?maxWidth=' +
        this.imagMaxWidth
      );
    },
    linkTo() {
      return this.eventEntry.linkTo;
    },
  },
  methods: {
    _oneDay(start, end, loc, showTime) {
      let result = this.$d(start, 'monthDay', loc);

      if (showTime) {
        result =
          result +
          ' <span class="font-large">|</span> ' +
          this.$d(start, 'hourMinute', loc) +
          ' - ' +
          this.$d(end, 'hourMinute', loc);
      }

      return result;
    },
    _moreDay(start, end, loc, showTime) {
      let result = this.$d(start, 'monthDay', loc);

      if (showTime) {
        result =
          result +
          ' <span class="card-timezone">|</span> ' +
          this.$d(start, 'hourMinute', loc);
      }

      result = result + ' - ' + this.$d(end, 'monthDay', loc);

      if (showTime) {
        result =
          result +
          ' <span class="card-timezone">|</span> ' +
          this.$d(end, 'hourMinute', loc);
      }

      return result;
    },
  },
};
</script>
